library lnk_trace;

uses
  Windows,kol,
  CGTShare in '..\..\Elements\CGTShare.pas';

type
  PPos = ^TPos;
  TPos = record
    X,Y:integer;
    Next:PPos;
    Prev:PPos;
  end;
  TAddProc = function(p:PPos; x,y:integer):PPos;
  TgetPPos = function(p:id_point):PPos;

const
  FACTOR = 100;
  step   = 5;
  _ac    = 6;
  exstep = 6;

const
  GetDataEx_ar_x1:array[0..3, 0..2] of integer = ((-2, 0, 1),
                                                  ( 2, 0, 0),
                                                  (-2, 0, 1),
                                                  ( 0, 0, 1));

  GetDataEx_ar_y1:array[0..3, 0..2] of integer = (( 0, 1, 0),
                                                  ( 0, 1,-1),
                                                  ( 0,-1, 0),
                                                  (-1, 1, 0));

  HubEx_ar_x1:    array[0..3, 0..2] of integer = (( 0,-1, 0),
                                                  ( 0,-1, 1),
                                                  ( 0, 1, 0),
                                                  ( 1,-1, 0));

  HubEx_ar_y1:    array[0..3, 0..2] of integer = ((-2, 0, 2),
                                                  (-2, 0, 0),
                                                  (-2, 0, 1),
                                                  ( 0, 0, 1));

  HubEx_ar_x2:    array[0..3] of integer = ( 2, 0,-2, 0);
  HubEx_ar_y2:    array[0..3] of integer = ( 0, 2, 0,-2);
  GetDataEx_ar_x2:array[0..3] of integer = ( 0, 2, 0,-3);
  GetDataEx_ar_y2:array[0..3] of integer = (-2, 0, 2, 0);


var
  m:array[0..127*_ac, 0..127*_ac] of Integer;
  md:array[0..127*_ac, 0..127*_ac] of Byte;
  sx:array[0..999] of Integer;
  sy:array[0..999] of Integer;
  st:array[0..999] of Integer;
  sd:array[0..999] of Integer;
  s1:Integer;
  s2:Integer;

  procedure mClear; forward;
  procedure mFill(x1,y1,x2,y2,nFill:Integer); forward;
  procedure mPop(var x,y,t,d:Integer); forward;
  procedure mPush(x,y,t,d:Integer); forward;
  function mSearch(x1,y1,x2,y2:Integer; p:PPos; add_proc:TAddProc; cgt:PCodeGenTools; data_pt:boolean):boolean; forward;

procedure mClear;
var  x:Integer; y:Integer;
begin
  for y := 0 to 127*_ac do
    for x := 0 to 127*_ac do
    begin
      if m[x, y] >= 0 then
        m[x, y] := 100000;
      md[x, y] := 0;
    end;
end;

procedure mFill(x1,y1,x2,y2,nFill:Integer);
var  x:Integer;
     y:Integer;
begin
  if y1 > y2 then
    Swap(y1,y2);
  if x1 > x2 then
    Swap(x1,x2);
  for y := y1 To y2 do
    for x := x1 To x2 do
      m[x, y] := nFill;
end;

procedure mPop(var x,y,t,d:Integer);
begin
  x := sx[s1];
  y := sy[s1];
  t := st[s1];
  d := sd[s1];
  s1 := (s1 + 1) Mod 1000;
end;

procedure mPush(x,y,t,d:Integer);
begin
  m[x, y] := t;
  md[x, y] := d;
  sx[s2] := x;
  sy[s2] := y;
  st[s2] := t;
  sd[s2] := d;
  s2 := (s2 + 1) Mod 1000;
end;

function IfThen(v:boolean; a,b:integer):integer;
begin
  if v then result := a else result := b;
end;

function mSearch(x1,y1,x2,y2:Integer; p:PPos; add_proc:TAddProc; cgt:PCodeGenTools; data_pt:boolean):boolean;
var  x,y,t,d,d1,xx,yy,xxx,yyy:Integer;
     old:byte;
     Line: boolean;
begin
  Result := true;
TRY
  if abs(x1 - (x2 div FACTOR)) > abs(y1 - (y2 div FACTOR)) then
    if x1 < (x2 div FACTOR) then
      d := 1
    else
      d := 2
  else
    if y1 < (y2 div FACTOR) then
      d := 3
    else
      d := 4;

  t  := 1;
  d1 := d;

  cgt._Debug(PChar('Start:' + int2str(d) + ', ' + int2str(x1 * step) + ', ' + int2str(y1 * step) + ', ' + int2str(x2 * step div FACTOR) + ', ' + int2str(y2 * step div FACTOR)), clGray);

  //    work-event     
  s1 := 0;
  s2 := 0;
  mPush(x1, y1, t, d1);
  mClear;


  if not data_pt then
  begin
    cgt._Debug(PChar('Main Work-Event Tracer'), clGreen);
    while s1 <> s2 do
    begin
      mPop(x, y, t, d);
      if (m[x + 1, y] > (t + IfThen(d = 1, 1, 2))) and (x < ((127 * _ac) - 1)) then
        mPush( x + 1, y, t + IfThen(d = 1, 1, 2), 1);
      if (m[x - 1, y] > (t + IfThen(d = 2, 1, 2))) and (x > 1) then
        mPush( x - 1, y, t + IfThen(d = 2, 1, 2), 2);
      if (m[x, y + 1] > (t + IfThen(d = 3, 1, 2))) and (y < ((127 * _ac) - 1)) then
        mPush( x, y + 1, t + IfThen(d = 3, 1, 2), 3);
      if (m[x, y - 1] > (t + IfThen(d = 4, 1, 2))) and (y > 1) then
        mPush( x, y - 1, t + IfThen(d = 4, 1, 2), 4);
    end;
  end;

  //    work-event    
  //        
  //         data-var

  if ((md[x2 div FACTOR, y2 div FACTOR] = 0){ and NotHLineDirect}) or data_pt then
  begin
    xx := x1;
    yy := y1;
    xxx := x2 div FACTOR;
    yyy := y2 div FACTOR;

    if (md[x2 div FACTOR, y2 div FACTOR] = 0) and not data_pt then
    begin
      cgt._Debug(PChar('Crosslink Work-Event Tracer'), clGreen);
      if (abs(y1) mod abs(y2 div FACTOR) <= step) then
      begin
        Line := true;
        if xx > xxx then
        Swap(xx,xxx);
        for x := xx to xxx do
          if m[x, y1] = -1 then
          begin
            Line := false;
            break;
          end;
        if Line then
        begin
          cgt._Debug(PChar('HLine Trace'), clNavy);
          exit;
        end;
      end;
    end
    else
    begin
      cgt._Debug(PChar('Crosslink Data-Var Tracer'), clGreen);
      if (abs(x1) mod abs(x2 div FACTOR) <= step) then
      begin
        Line := true;
        if yy > yyy then
        Swap(yy,yyy);
        for y := yy to yyy do
          if m[x1, y] = -1 then
          begin
            Line := false;
            break;
          end;
        if Line then
        begin
          cgt._Debug(PChar('VLine Trace'), clNavy);
          exit;
        end;
      end;
    end;
    
    s1 := 0;
    s2 := 0;
    mPush(x1, y1, t, d1);
    mClear;

    while s1 <> s2 do
    begin
      mPop(x, y, t, d);
      if ((m[x + 1, y] > (t + IfThen(d = 1, 1, 2))) or (m[x + 1, y] = -2)) and (x < ((127 * _ac) - 1)) then
        mPush( x + 1, y, t + IfThen(d = 1, 1, 2), 1);
      if ((m[x - 1, y] > (t + IfThen(d = 2, 1, 2))) or (m[x - 1, y] = -2))and (x > 1) then
        mPush( x - 1, y, t + IfThen(d = 2, 1, 2), 2);
      if ((m[x, y + 1] > (t + IfThen(d = 3, 1, 2))) or (m[x, y + 1] = -2)) and (y < ((127 * _ac) - 1)) then
        mPush( x, y + 1, t + IfThen(d = 3, 1, 2), 3);
      if ((m[x, y - 1] > (t + IfThen(d = 4, 1, 2))) or (m[x, y - 1] = -2)) and (y > 1) then
        mPush( x, y - 1, t + IfThen(d = 4, 1, 2), 4);
    end;
  end;

  x := x2;
  y := y2;
  xx := x div FACTOR;
  yy := y div FACTOR;

  old := 0;
  m[xx, yy] := -2;
  while (xx <> x1) or (yy <> y1) do
  begin
    case md[xx, yy] of
      1: dec(x, FACTOR div 10);
      2: inc(x, FACTOR div 10);
      3: dec(y, FACTOR div 10);
      4: inc(y, FACTOR div 10);
      else
      begin
        cgt._Debug(PChar('Not Traced'), clRed);
        Result := false;
        break;
      end;
    end;
    xx := x div FACTOR;
    yy := y div FACTOR;
    if md[xx, yy] <> old then // ,    
      p := add_proc(p, (x * step) div FACTOR, (y * step) div FACTOR); //  , - 
    old := md[xx, yy];
    m[xx, yy] := -2;
  end;
FINALLY
  cgt._Debug(PChar('Done'), clGray);
END;
end;

function trace(cgt:PCodeGenTools; sdk:id_sdk; point:id_point; p:PPos; add_proc:TAddProc; getPPos:TgetPPos):boolean;
var  e:id_element;
     i,j:integer;
//     angle,idx,idx0:integer;
     pt:id_point;
//     pr:id_prop;
     x,y,w,h,_x1,_y1,_x2,_y2:integer;
     ps:PPos;
     data_pt:boolean;
     Name:string;
//     propName:string;
begin
//  Result := true;
  mClear;
  for i := 0 to cgt.sdkGetCount(sdk)-1 do
  begin
    e := cgt.sdkGetElement(sdk,i);
    cgt.elGetPos(e,x,y);
    cgt.elGetSize(e,w,h);
    mFill( x div step - 1, y div step, (x + w) div step, (y + h) div step , -1 );
    for j := 0 to cgt.elGetPtCount(e)-1 do
    begin
      pt := cgt.elGetPt(e,j);
      if cgt.ptGetLinkPoint(pt) <> 0 then
      begin
        if cgt.ptGetType(pt) in [pt_event, pt_data] then
          ps := getPPos(pt)
        else
          ps := getPPos(cgt.ptGetLinkPoint(pt));
        repeat
          if (ps.x = ps.Next.x) then
            mFill( ps.x div step, ps.y div step, ps.x div step, ps.Next.y div step, -2 )
          else if (ps.y = ps.Next.y) then
            mFill( ps.x div step, ps.y div step, ps.Next.x div step, ps.y div step, -2 );
          ps := ps.Next;
        until ps.Next = nil;
      end;
    end;
  end;

  pt := cgt.ptGetLinkPoint(point);

  e := cgt.ptGetParent(pt);
  Name := cgt.elGetClassName(e);
{
  pr := 0;
  angle := 0;
  idx := 0;
  if (Name = 'GetDataEx') or (Name = 'HubEx') then
  begin
    for j := 0 to cgt.elGetPtCount(e)-1 do
    begin
      pr := cgt.elGetProperty(e,j);
      propName := cgt.propGetName(pr);
      if propName = 'Angle' then
        break;
    end;
    angle := byte(cgt.propToInteger(pr));
    idx := cgt.ptGetIndex(pt);
  end;
}
  ps := getPPos(point);
  _x2 := ps.x;
  _y2 := ps.y;

  with getPPos(pt)^ do
  begin
    _x1 := x;
    _y1 := y;
  end;

  if (Name = 'HubEx') then
  begin
    cgt._Debug(PChar('Work Point HubEx'), clNavy);
    add_proc(p, _x1, _y2); //    -
    Result := false;
    exit;
  end
  else if (Name = 'GetDataEx') then
  begin
    cgt._Debug(PChar('Var Point GetDataEx'), clNavy);
    add_proc(p, _x2, _y1); //    -
    Result := false;
    exit;
  end;

  if cgt.ptGetType(pt) = pt_work then
{
  begin
    if Name = 'HubEx' then
    begin
      _x1 := _x1 + exstep * HubEx_ar_x1[angle,idx];
      _y1 := _y1 + exstep * HubEx_ar_y1[angle,idx];
    end
    else
}
      dec(_x1,step)
  else
{
  begin
    if Name = 'GetDataEx' then
    begin
      _x1 := _x1 + exstep * GetDataEx_ar_x1[angle,idx];
      _y1 := _y1 + exstep * GetDataEx_ar_y1[angle,idx];
    end
    else
}
      inc(_y1,step);
//  end;

  e := cgt.ptGetParent(point);
  Name := cgt.elGetClassName(e);
{
  if (Name = 'GetDataEx') or (Name = 'HubEx') then
  begin
    for j := 0 to cgt.elGetPtCount(e)-1 do
    begin
      pr := cgt.elGetProperty(e,j);
      propName := cgt.propGetName(pr);
      if propName = 'Angle' then
        break;
    end;
    angle := byte(cgt.propToInteger(pr));
  end;
}
  if cgt.ptGetType(point) = pt_event then
  begin
    if Name = 'HubEx' then
{
    begin
      _x2 := _x2 + exstep * HubEx_ar_x2[angle];
      _y2 := _y2 + exstep * HubEx_ar_y2[angle];
    end
}
    begin
      cgt._Debug(PChar('Event Point HubEx'), clNavy);
      add_proc(p, _x2, _y1); //    -
      Result := false;
      exit;
    end
    else
      inc(_x2,step);
    data_pt := false;
  end
  else
  begin
    if Name = 'GetDataEx' then
{
    begin
      _x2 := _x2 + exstep * GetDataEx_ar_x2[angle];
      _y2 := _y2 + exstep * GetDataEx_ar_y2[angle];
    end
}
    begin
      cgt._Debug(PChar('Data Point GetDataEx'), clNavy);
      add_proc(p, _x1, _y2); //    -
      Result := false;
      exit;
    end
    else
      dec(_y2,step);
    data_pt := true;
  end;
  Result := mSearch(_x1 div step, _y1 div step, _x2 * FACTOR div step, _y2 * FACTOR div step, p, add_proc, cgt, data_pt);
end;

exports
  trace;

begin
end.